SystemOrganization addCategory: #'SqueakSource-Storage-Dictionary'!

SSStorage subclass: #SSDictionaryStorage
	instanceVariableNames: 'semaphore dictionary repository queue log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Storage-Dictionary'!

!SSDictionaryStorage class methodsFor: 'as yet unclassified' stamp: 'jgf 7/24/2009 08:12'!
new

	^self basicNew
		initialize;
		yourself.! !

!SSDictionaryStorage class methodsFor: 'as yet unclassified' stamp: 'jgf 7/24/2009 10:21'!
reset! !

!SSDictionaryStorage methodsFor: 'logging' stamp: 'dkh 05/23/2011 16:43'!
getLogOfSize: anInteger 
	"since we are counting lines, not characters, we'll divide anInteger by 80"
	| strm |
	log addAll: (queue _timeSortedComponents collect: [:ea | ea value]).
	queue removeAll.
	strm := WriteStream on: String new.
	(1 max: log size - (anInteger/80) + 1) to: log size do: [:index | strm nextPutAll: (log at: index) ].
	^strm contents! !

!SSDictionaryStorage methodsFor: 'as yet unclassified' stamp: 'topa 5/24/2011 15:07'!
initialize

	super initialize.
	semaphore := GRPlatform current semaphoreClass new.
	dictionary := GRPlatform current reducedConflictDictionary new.
	repository := nil.
	log := OrderedCollection new.
	queue := GRPlatform current reducedConflictQueue new.! !

!SSDictionaryStorage methodsFor: 'as yet unclassified' stamp: 'topa 3/31/2011 10:29'!
keyForDiffyVersionNamed: aFileName project: aProject

	^ aProject id, '/', aFileName.! !

!SSDictionaryStorage methodsFor: 'as yet unclassified' stamp: 'topa 3/31/2011 10:30'!
keyForVersion: aVersion project: aProject

	^ aProject id, '/', aVersion fileName.! !

!SSDictionaryStorage methodsFor: 'actions' stamp: 'topa 3/31/2011 10:31'!
loadDiffNamed: aVersion from: aProject

	^dictionary at: (self keyForDiffyVersionNamed: aVersion project: aProject).! !

!SSDictionaryStorage methodsFor: 'actions' stamp: 'jgf 7/24/2009 08:28'!
loadMonticello: aVersion from: aProject

	^dictionary at: (self keyForVersion: aVersion project: aProject).! !

!SSDictionaryStorage methodsFor: 'actions' stamp: 'topa 3/31/2011 10:00'!
loadRepository
	
	^ repository! !

!SSDictionaryStorage methodsFor: 'logging' stamp: 'dkh 05/23/2011 16:16'!
log: aString

	| strm |
	strm := WriteStream on: String new.
	strm
		nextPutAll: DateAndTime now asString; 
		space;
		nextPutAll: aString;
		cr.
	queue add: strm contents! !

!SSDictionaryStorage methodsFor: 'actions' stamp: 'topa 3/31/2011 10:28'!
saveDiff: aByteArray named: aFileName to: aProject

	dictionary 
		at: (self keyForDiffyVersionNamed: aFileName project: aProject) 
		put: aByteArray.! !

!SSDictionaryStorage methodsFor: 'actions' stamp: 'jgf 7/24/2009 08:28'!
saveMonticello: aString of: aVersion to: aProject

	dictionary 
		at: (self keyForVersion: aVersion project: aProject) 
		put: aString.! !

!SSDictionaryStorage methodsFor: 'actions' stamp: 'jgf 7/24/2009 10:04'!
saveRepository: aRepository
	
	repository := aRepository.! !

SSDictionaryStorage subclass: #SSNestedDictionaryStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Storage-Dictionary'!

!SSNestedDictionaryStorage methodsFor: 'private' stamp: 'dkh 05/18/2011 08:50'!
getProjectDictionaryFor: aProjectId

	^dictionary 
		at: aProjectId
			ifAbsent: [
				dictionary 
					at: aProjectId
					put: GRPlatform current reducedConflictDictionary new ].! !

!SSNestedDictionaryStorage methodsFor: 'actions' stamp: 'dkh 05/18/2011 08:51'!
loadDiffNamed: aVersionName from: aProject

	^(self getProjectDictionaryFor: aProject id) at: aVersionName! !

!SSNestedDictionaryStorage methodsFor: 'actions' stamp: 'dkh 05/18/2011 08:52'!
loadMonticello: aVersion from: aProject

	^(self getProjectDictionaryFor: aProject id) at: aVersion fileName! !

!SSNestedDictionaryStorage methodsFor: 'actions' stamp: 'dkh 05/18/2011 08:59'!
saveDiff: aByteArray named: aFileName to: aProject

	(self getProjectDictionaryFor: aProject id) at: aFileName put: aByteArray! !

!SSNestedDictionaryStorage methodsFor: 'actions' stamp: 'dkh 05/18/2011 09:00'!
saveMonticello: aByteArray of: aVersion to: aProject

	(self getProjectDictionaryFor: aProject id) at: aVersion fileName put: aByteArray! !
